/* IOHelper.c generated by valac 0.48.8, the Vala compiler
 * generated from IOHelper.vala, do not modify */

/*-
 * Copyright (c) 2017-2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

#define TYPE_IO_HELPER (io_helper_get_type ())
#define IO_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IO_HELPER, IOHelper))
#define IO_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IO_HELPER, IOHelperClass))
#define IS_IO_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IO_HELPER))
#define IS_IO_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IO_HELPER))
#define IO_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IO_HELPER, IOHelperClass))

typedef struct _IOHelper IOHelper;
typedef struct _IOHelperClass IOHelperClass;
typedef struct _IOHelperPrivate IOHelperPrivate;
enum  {
	IO_HELPER_0_PROPERTY,
	IO_HELPER_NUM_PROPERTIES
};
static GParamSpec* io_helper_properties[IO_HELPER_NUM_PROPERTIES];

struct _IOHelper {
	GObject parent_instance;
	IOHelperPrivate * priv;
};

struct _IOHelperClass {
	GObjectClass parent_class;
};

static gpointer io_helper_parent_class = NULL;

GType io_helper_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IOHelper, g_object_unref)
gboolean io_helper_is_valid_file_type (GFileInfo* file_info);
IOHelper* io_helper_new (void);
IOHelper* io_helper_construct (GType object_type);
static GType io_helper_get_type_once (void);

static const gchar* IO_HELPER_ACCEPTED_TYPES[5] = {"image/jpeg", "image/png", "image/tiff", "image/svg+xml", "image/gif"};

gboolean
io_helper_is_valid_file_type (GFileInfo* file_info)
{
	gboolean result = FALSE;
	g_return_val_if_fail (file_info != NULL, FALSE);
	if (g_file_info_get_file_type (file_info) != G_FILE_TYPE_REGULAR) {
		result = FALSE;
		return result;
	}
	{
		const gchar** type_collection = NULL;
		gint type_collection_length1 = 0;
		gint _type_collection_size_ = 0;
		gint type_it = 0;
		type_collection = IO_HELPER_ACCEPTED_TYPES;
		type_collection_length1 = G_N_ELEMENTS (IO_HELPER_ACCEPTED_TYPES);
		for (type_it = 0; type_it < type_collection_length1; type_it = type_it + 1) {
			const gchar* type = NULL;
			type = type_collection[type_it];
			{
				const gchar* _tmp0_;
				const gchar* _tmp1_;
				_tmp0_ = g_file_info_get_content_type (file_info);
				_tmp1_ = type;
				if (g_content_type_equals (_tmp0_, _tmp1_)) {
					result = TRUE;
					return result;
				}
			}
		}
	}
	result = FALSE;
	return result;
}

IOHelper*
io_helper_construct (GType object_type)
{
	IOHelper * self = NULL;
	self = (IOHelper*) g_object_new (object_type, NULL);
	return self;
}

IOHelper*
io_helper_new (void)
{
	return io_helper_construct (TYPE_IO_HELPER);
}

static void
io_helper_class_init (IOHelperClass * klass,
                      gpointer klass_data)
{
	io_helper_parent_class = g_type_class_peek_parent (klass);
}

static void
io_helper_instance_init (IOHelper * self,
                         gpointer klass)
{
}

static GType
io_helper_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IOHelperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) io_helper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IOHelper), 0, (GInstanceInitFunc) io_helper_instance_init, NULL };
	GType io_helper_type_id;
	io_helper_type_id = g_type_register_static (G_TYPE_OBJECT, "IOHelper", &g_define_type_info, 0);
	return io_helper_type_id;
}

GType
io_helper_get_type (void)
{
	static volatile gsize io_helper_type_id__volatile = 0;
	if (g_once_init_enter (&io_helper_type_id__volatile)) {
		GType io_helper_type_id;
		io_helper_type_id = io_helper_get_type_once ();
		g_once_init_leave (&io_helper_type_id__volatile, io_helper_type_id);
	}
	return io_helper_type_id__volatile;
}

