/* WallpaperContainer.c generated by valac 0.48.8, the Vala compiler
 * generated from WallpaperContainer.vala, do not modify */

/*-
 * Copyright (c) 2015-2017 elementary LLC. (https://bugs.launchpad.net/switchboard-plug-pantheon-shell)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Erasmo Marín
 *
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#define TYPE_WALLPAPER_CONTAINER (wallpaper_container_get_type ())
#define WALLPAPER_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WALLPAPER_CONTAINER, WallpaperContainer))
#define WALLPAPER_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WALLPAPER_CONTAINER, WallpaperContainerClass))
#define IS_WALLPAPER_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WALLPAPER_CONTAINER))
#define IS_WALLPAPER_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WALLPAPER_CONTAINER))
#define WALLPAPER_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WALLPAPER_CONTAINER, WallpaperContainerClass))

typedef struct _WallpaperContainer WallpaperContainer;
typedef struct _WallpaperContainerClass WallpaperContainerClass;
typedef struct _WallpaperContainerPrivate WallpaperContainerPrivate;
enum  {
	WALLPAPER_CONTAINER_0_PROPERTY,
	WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY,
	WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY,
	WALLPAPER_CONTAINER_URI_PROPERTY,
	WALLPAPER_CONTAINER_THUMB_PROPERTY,
	WALLPAPER_CONTAINER_CHECKED_PROPERTY,
	WALLPAPER_CONTAINER_SELECTED_PROPERTY,
	WALLPAPER_CONTAINER_NUM_PROPERTIES
};
static GParamSpec* wallpaper_container_properties[WALLPAPER_CONTAINER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_THUMBNAIL_GENERATOR (thumbnail_generator_get_type ())
#define THUMBNAIL_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_GENERATOR, ThumbnailGenerator))
#define THUMBNAIL_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_GENERATOR, ThumbnailGeneratorClass))
#define IS_THUMBNAIL_GENERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_GENERATOR))
#define IS_THUMBNAIL_GENERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_GENERATOR))
#define THUMBNAIL_GENERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_GENERATOR, ThumbnailGeneratorClass))

typedef struct _ThumbnailGenerator ThumbnailGenerator;
typedef struct _ThumbnailGeneratorClass ThumbnailGeneratorClass;
typedef void (*ThumbnailGeneratorThumbnailReady) (gpointer user_data);
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _thumbnail_generator_unref0(var) ((var == NULL) ? NULL : (var = (thumbnail_generator_unref (var), NULL)))
typedef struct _WallpaperContainerUpdateThumbData WallpaperContainerUpdateThumbData;
typedef struct _Block1Data Block1Data;
enum  {
	WALLPAPER_CONTAINER_TRASH_SIGNAL,
	WALLPAPER_CONTAINER_NUM_SIGNALS
};
static guint wallpaper_container_signals[WALLPAPER_CONTAINER_NUM_SIGNALS] = {0};

struct _WallpaperContainer {
	GtkFlowBoxChild parent_instance;
	WallpaperContainerPrivate * priv;
};

struct _WallpaperContainerClass {
	GtkFlowBoxChildClass parent_class;
};

struct _WallpaperContainerPrivate {
	GtkGrid* card_box;
	GtkMenu* context_menu;
	GtkRevealer* check_revealer;
	GraniteAsyncImage* image;
	gchar* _thumb_path;
	gboolean _thumb_valid;
	gchar* _uri;
	GdkPixbuf* _thumb;
	gint scale;
};

struct _WallpaperContainerUpdateThumbData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WallpaperContainer* self;
	const gchar* _tmp0_;
	GraniteAsyncImage* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GError* e;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	WallpaperContainer* self;
	GtkMenuItem* move_to_trash;
	GFile* file;
};

static gint WallpaperContainer_private_offset;
static gpointer wallpaper_container_parent_class = NULL;

GType wallpaper_container_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WallpaperContainer, g_object_unref)
#define WALLPAPER_CONTAINER_THUMB_WIDTH 162
#define WALLPAPER_CONTAINER_THUMB_HEIGHT 100
WallpaperContainer* wallpaper_container_new (const gchar* uri,
                                             const gchar* thumb_path,
                                             gboolean thumb_valid);
WallpaperContainer* wallpaper_container_construct (GType object_type,
                                                   const gchar* uri,
                                                   const gchar* thumb_path,
                                                   gboolean thumb_valid);
static void wallpaper_container_generate_and_load_thumb (WallpaperContainer* self);
gpointer thumbnail_generator_ref (gpointer instance);
void thumbnail_generator_unref (gpointer instance);
GParamSpec* param_spec_thumbnail_generator (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_thumbnail_generator (GValue* value,
                                    gpointer v_object);
void value_take_thumbnail_generator (GValue* value,
                                     gpointer v_object);
gpointer value_get_thumbnail_generator (const GValue* value);
GType thumbnail_generator_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailGenerator, thumbnail_generator_unref)
ThumbnailGenerator* thumbnail_generator_get_default (void);
void thumbnail_generator_get_thumbnail (ThumbnailGenerator* self,
                                        const gchar* uri,
                                        guint size,
                                        ThumbnailGeneratorThumbnailReady callback,
                                        gpointer callback_target);
const gchar* wallpaper_container_get_uri (WallpaperContainer* self);
static void __lambda6_ (WallpaperContainer* self);
void wallpaper_container_set_thumb_path (WallpaperContainer* self,
                                         const gchar* value);
static void wallpaper_container_update_thumb (WallpaperContainer* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static void wallpaper_container_update_thumb_finish (WallpaperContainer* self,
                                              GAsyncResult* _res_);
static void ___lambda6__thumbnail_generator_thumbnail_ready (gpointer self);
static void wallpaper_container_load_artist_tooltip (WallpaperContainer* self);
static gboolean wallpaper_container_show_context_menu (WallpaperContainer* self,
                                                GtkWidget* sender,
                                                GdkEventButton* evt);
static void wallpaper_container_update_thumb_data_free (gpointer _data);
static gboolean wallpaper_container_update_thumb_co (WallpaperContainerUpdateThumbData* _data_);
const gchar* wallpaper_container_get_thumb_path (WallpaperContainer* self);
static void wallpaper_container_update_thumb_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
gboolean wallpaper_container_get_thumb_valid (WallpaperContainer* self);
static void wallpaper_container_set_thumb_valid (WallpaperContainer* self,
                                          gboolean value);
static void wallpaper_container_set_uri (WallpaperContainer* self,
                                  const gchar* value);
GdkPixbuf* wallpaper_container_get_thumb (WallpaperContainer* self);
void wallpaper_container_set_thumb (WallpaperContainer* self,
                                    GdkPixbuf* value);
gboolean wallpaper_container_get_checked (WallpaperContainer* self);
void wallpaper_container_set_checked (WallpaperContainer* self,
                                      gboolean value);
gboolean wallpaper_container_get_selected (WallpaperContainer* self);
void wallpaper_container_set_selected (WallpaperContainer* self,
                                       gboolean value);
static GObject * wallpaper_container_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _wallpaper_container____lambda7_ (WallpaperContainer* self);
static void __wallpaper_container____lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                               gpointer self);
static void _wallpaper_container____lambda8_ (Block1Data* _data1_,
                                       GObject* obj,
                                       GAsyncResult* res);
static void __wallpaper_container____lambda8__gasync_ready_callback (GObject* source_object,
                                                              GAsyncResult* res,
                                                              gpointer self);
static void _wallpaper_container___lambda9_ (WallpaperContainer* self);
static void __wallpaper_container___lambda9__gtk_flow_box_child_activate (GtkFlowBoxChild* _sender,
                                                                   gpointer self);
static gboolean _wallpaper_container_show_context_menu_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                               GdkEventButton* event,
                                                                               gpointer self);
static void wallpaper_container_finalize (GObject * obj);
static GType wallpaper_container_get_type_once (void);
static void _vala_wallpaper_container_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_wallpaper_container_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
wallpaper_container_get_instance_private (WallpaperContainer* self)
{
	return G_STRUCT_MEMBER_P (self, WallpaperContainer_private_offset);
}

WallpaperContainer*
wallpaper_container_construct (GType object_type,
                               const gchar* uri,
                               const gchar* thumb_path,
                               gboolean thumb_valid)
{
	WallpaperContainer * self = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	self = (WallpaperContainer*) g_object_new (object_type, "uri", uri, "thumb-path", thumb_path, "thumb-valid", thumb_valid, NULL);
	return self;
}

WallpaperContainer*
wallpaper_container_new (const gchar* uri,
                         const gchar* thumb_path,
                         gboolean thumb_valid)
{
	return wallpaper_container_construct (TYPE_WALLPAPER_CONTAINER, uri, thumb_path, thumb_valid);
}

static void
__lambda6_ (WallpaperContainer* self)
{
	GError* _inner_error0_ = NULL;
	{
		GFile* file = NULL;
		const gchar* _tmp0_;
		GFile* _tmp1_;
		GFileInfo* info = NULL;
		GFileInfo* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp0_ = self->priv->_uri;
		_tmp1_ = g_file_new_for_uri (_tmp0_);
		file = _tmp1_;
		_tmp2_ = g_file_query_info (file, G_FILE_ATTRIBUTE_THUMBNAIL_PATH "," G_FILE_ATTRIBUTE_THUMBNAIL_IS_VALID, 0, NULL, &_inner_error0_);
		info = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			goto __catch0_g_error;
		}
		_tmp3_ = g_file_info_get_attribute_as_string (info, G_FILE_ATTRIBUTE_THUMBNAIL_PATH);
		_tmp4_ = _tmp3_;
		wallpaper_container_set_thumb_path (self, _tmp4_);
		_g_free0 (_tmp4_);
		wallpaper_container_update_thumb (self, NULL, NULL);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = self->priv->_uri;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_warning ("WallpaperContainer.vala:167: Error loading thumbnail for '%s': %s", _tmp5_, _tmp7_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda6__thumbnail_generator_thumbnail_ready (gpointer self)
{
	__lambda6_ ((WallpaperContainer*) self);
}

static void
wallpaper_container_generate_and_load_thumb (WallpaperContainer* self)
{
	ThumbnailGenerator* _tmp0_;
	ThumbnailGenerator* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = thumbnail_generator_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_uri;
	thumbnail_generator_get_thumbnail (_tmp1_, _tmp2_, (guint) (WALLPAPER_CONTAINER_THUMB_WIDTH * self->priv->scale), ___lambda6__thumbnail_generator_thumbnail_ready, self);
	_thumbnail_generator_unref0 (_tmp1_);
}

static void
wallpaper_container_load_artist_tooltip (WallpaperContainer* self)
{
	const gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_uri;
	if (_tmp0_ != NULL) {
		gchar* path = NULL;
		gchar* _tmp1_;
		GExiv2Metadata* metadata = NULL;
		GExiv2Metadata* _tmp12_;
		_tmp1_ = g_strdup ("");
		path = _tmp1_;
		{
			gchar* _tmp2_ = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GExiv2Metadata* _tmp6_;
			GExiv2Metadata* _tmp7_;
			const gchar* _tmp8_;
			_tmp3_ = self->priv->_uri;
			_tmp4_ = g_filename_from_uri (_tmp3_, NULL, &_inner_error0_);
			_tmp2_ = _tmp4_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp5_ = _tmp2_;
			_tmp2_ = NULL;
			_g_free0 (path);
			path = _tmp5_;
			_tmp6_ = gexiv2_metadata_new ();
			_g_object_unref0 (metadata);
			metadata = _tmp6_;
			_tmp7_ = metadata;
			_tmp8_ = path;
			gexiv2_metadata_open_path (_tmp7_, _tmp8_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (_tmp2_);
				goto __catch0_g_error;
			}
			_g_free0 (_tmp2_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp9_;
			GError* _tmp10_;
			const gchar* _tmp11_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp9_ = path;
			_tmp10_ = e;
			_tmp11_ = _tmp10_->message;
			g_warning ("WallpaperContainer.vala:181: Error parsing exif metadata of \"%s\": %s", _tmp9_, _tmp11_);
			_g_error_free0 (e);
			_g_object_unref0 (metadata);
			_g_free0 (path);
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (metadata);
			_g_free0 (path);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp12_ = metadata;
		if (gexiv2_metadata_has_exif (_tmp12_)) {
			gchar* artist_name = NULL;
			GExiv2Metadata* _tmp13_;
			gchar* _tmp14_;
			const gchar* _tmp15_;
			_tmp13_ = metadata;
			_tmp14_ = gexiv2_metadata_get_tag_string (_tmp13_, "Exif.Image.Artist");
			artist_name = _tmp14_;
			_tmp15_ = artist_name;
			if (_tmp15_ != NULL) {
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				_tmp16_ = artist_name;
				_tmp17_ = g_strdup_printf (_ ("Artist: %s"), _tmp16_);
				_tmp18_ = _tmp17_;
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp18_);
				_g_free0 (_tmp18_);
			}
			_g_free0 (artist_name);
		}
		_g_object_unref0 (metadata);
		_g_free0 (path);
	}
}

static gboolean
wallpaper_container_show_context_menu (WallpaperContainer* self,
                                       GtkWidget* sender,
                                       GdkEventButton* evt)
{
	gboolean _tmp0_ = FALSE;
	GdkEventType _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (sender != NULL, FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp1_ = evt->type;
	if (_tmp1_ == GDK_BUTTON_PRESS) {
		_tmp0_ = evt->button == ((guint) 3);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkMenu* _tmp2_;
		_tmp2_ = self->priv->context_menu;
		gtk_menu_popup_at_pointer (_tmp2_, NULL);
		result = GDK_EVENT_STOP;
		return result;
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static void
wallpaper_container_update_thumb_data_free (gpointer _data)
{
	WallpaperContainerUpdateThumbData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (WallpaperContainerUpdateThumbData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
wallpaper_container_update_thumb (WallpaperContainer* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	WallpaperContainerUpdateThumbData* _data_;
	WallpaperContainer* _tmp0_;
	_data_ = g_slice_new0 (WallpaperContainerUpdateThumbData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, wallpaper_container_update_thumb_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	wallpaper_container_update_thumb_co (_data_);
}

static void
wallpaper_container_update_thumb_finish (WallpaperContainer* self,
                                         GAsyncResult* _res_)
{
	WallpaperContainerUpdateThumbData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
wallpaper_container_update_thumb_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	WallpaperContainerUpdateThumbData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	wallpaper_container_update_thumb_co (_data_);
}

static gboolean
wallpaper_container_update_thumb_co (WallpaperContainerUpdateThumbData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->_thumb_path;
	if (_data_->_tmp0_ == NULL) {
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	{
		_data_->_tmp1_ = _data_->self->priv->image;
		_data_->_tmp2_ = _data_->self->priv->_thumb_path;
		_data_->_tmp3_ = g_file_new_for_path (_data_->_tmp2_);
		_data_->_tmp4_ = _data_->_tmp3_;
		_data_->_state_ = 1;
		granite_async_image_set_from_file_async (_data_->_tmp1_, _data_->_tmp4_, WALLPAPER_CONTAINER_THUMB_WIDTH, WALLPAPER_CONTAINER_THUMB_HEIGHT, FALSE, NULL, wallpaper_container_update_thumb_ready, _data_);
		return FALSE;
		_state_1:
		granite_async_image_set_from_file_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
		_g_object_unref0 (_data_->_tmp4_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp5_ = _data_->e;
		_data_->_tmp6_ = _data_->_tmp5_->message;
		g_warning ("WallpaperContainer.vala:210: %s", _data_->_tmp6_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	wallpaper_container_load_artist_tooltip (_data_->self);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

const gchar*
wallpaper_container_get_thumb_path (WallpaperContainer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_thumb_path;
	result = _tmp0_;
	return result;
}

void
wallpaper_container_set_thumb_path (WallpaperContainer* self,
                                    const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, wallpaper_container_get_thumb_path (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_thumb_path);
		self->priv->_thumb_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY]);
	}
}

gboolean
wallpaper_container_get_thumb_valid (WallpaperContainer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_thumb_valid;
	return result;
}

static void
wallpaper_container_set_thumb_valid (WallpaperContainer* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	if (wallpaper_container_get_thumb_valid (self) != value) {
		self->priv->_thumb_valid = value;
		g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY]);
	}
}

const gchar*
wallpaper_container_get_uri (WallpaperContainer* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_uri;
	result = _tmp0_;
	return result;
}

static void
wallpaper_container_set_uri (WallpaperContainer* self,
                             const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, wallpaper_container_get_uri (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_uri);
		self->priv->_uri = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_URI_PROPERTY]);
	}
}

GdkPixbuf*
wallpaper_container_get_thumb (WallpaperContainer* self)
{
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_thumb;
	result = _tmp0_;
	return result;
}

void
wallpaper_container_set_thumb (WallpaperContainer* self,
                               GdkPixbuf* value)
{
	g_return_if_fail (self != NULL);
	if (wallpaper_container_get_thumb (self) != value) {
		GdkPixbuf* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_thumb);
		self->priv->_thumb = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_PROPERTY]);
	}
}

gboolean
wallpaper_container_get_checked (WallpaperContainer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (gtk_widget_get_state_flags ((GtkWidget*) self) & GTK_STATE_FLAG_CHECKED) == GTK_STATE_FLAG_CHECKED;
	return result;
}

void
wallpaper_container_set_checked (WallpaperContainer* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	if (value) {
		GtkGrid* _tmp0_;
		GtkRevealer* _tmp1_;
		_tmp0_ = self->priv->card_box;
		gtk_widget_set_state_flags ((GtkWidget*) _tmp0_, GTK_STATE_FLAG_CHECKED, FALSE);
		_tmp1_ = self->priv->check_revealer;
		gtk_revealer_set_reveal_child (_tmp1_, TRUE);
	} else {
		GtkGrid* _tmp2_;
		GtkRevealer* _tmp3_;
		_tmp2_ = self->priv->card_box;
		gtk_widget_unset_state_flags ((GtkWidget*) _tmp2_, GTK_STATE_FLAG_CHECKED);
		_tmp3_ = self->priv->check_revealer;
		gtk_revealer_set_reveal_child (_tmp3_, FALSE);
	}
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_CHECKED_PROPERTY]);
}

gboolean
wallpaper_container_get_selected (WallpaperContainer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = (gtk_widget_get_state_flags ((GtkWidget*) self) & GTK_STATE_FLAG_SELECTED) == GTK_STATE_FLAG_SELECTED;
	return result;
}

void
wallpaper_container_set_selected (WallpaperContainer* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	if (value) {
		gtk_widget_set_state_flags ((GtkWidget*) self, GTK_STATE_FLAG_SELECTED, FALSE);
	} else {
		gtk_widget_unset_state_flags ((GtkWidget*) self, GTK_STATE_FLAG_SELECTED);
	}
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, wallpaper_container_properties[WALLPAPER_CONTAINER_SELECTED_PROPERTY]);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		WallpaperContainer* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->file);
		_g_object_unref0 (_data1_->move_to_trash);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
_wallpaper_container____lambda7_ (WallpaperContainer* self)
{
	g_signal_emit (self, wallpaper_container_signals[WALLPAPER_CONTAINER_TRASH_SIGNAL], 0);
}

static void
__wallpaper_container____lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self)
{
	_wallpaper_container____lambda7_ ((WallpaperContainer*) self);
}

static void
_wallpaper_container____lambda8_ (Block1Data* _data1_,
                                  GObject* obj,
                                  GAsyncResult* res)
{
	WallpaperContainer* self;
	GError* _inner_error0_ = NULL;
	self = _data1_->self;
	g_return_if_fail (res != NULL);
	{
		GFileInfo* info = NULL;
		GFile* _tmp0_;
		GFileInfo* _tmp1_;
		GtkMenuItem* _tmp2_;
		GFileInfo* _tmp3_;
		_tmp0_ = _data1_->file;
		_tmp1_ = g_file_query_info_finish (_tmp0_, res, &_inner_error0_);
		info = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _data1_->move_to_trash;
		_tmp3_ = info;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, g_file_info_get_attribute_boolean (_tmp3_, G_FILE_ATTRIBUTE_ACCESS_CAN_DELETE));
		_g_object_unref0 (info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_critical ("WallpaperContainer.vala:127: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__wallpaper_container____lambda8__gasync_ready_callback (GObject* source_object,
                                                         GAsyncResult* res,
                                                         gpointer self)
{
	_wallpaper_container____lambda8_ (self, source_object, res);
	block1_data_unref (self);
}

static void
_wallpaper_container___lambda9_ (WallpaperContainer* self)
{
	wallpaper_container_set_checked (self, TRUE);
}

static void
__wallpaper_container___lambda9__gtk_flow_box_child_activate (GtkFlowBoxChild* _sender,
                                                              gpointer self)
{
	_wallpaper_container___lambda9_ ((WallpaperContainer*) self);
}

static gboolean
_wallpaper_container_show_context_menu_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self)
{
	gboolean result;
	result = wallpaper_container_show_context_menu ((WallpaperContainer*) self, _sender, event);
	return result;
}

static GObject *
wallpaper_container_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WallpaperContainer * self;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp4_;
	GtkCssProvider* _tmp5_;
	GdkScreen* _tmp6_;
	GtkCssProvider* _tmp7_;
	GraniteAsyncImage* _tmp8_;
	GraniteAsyncImage* _tmp9_;
	GraniteAsyncImage* _tmp10_;
	GraniteAsyncImage* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkGrid* _tmp16_;
	GraniteAsyncImage* _tmp17_;
	GtkGrid* _tmp18_;
	GtkImage* check = NULL;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkRevealer* _tmp22_;
	GtkRevealer* _tmp23_;
	GtkRevealer* _tmp24_;
	GtkImage* _tmp25_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp26_;
	GtkOverlay* _tmp27_;
	GtkGrid* _tmp28_;
	GtkOverlay* _tmp29_;
	GtkRevealer* _tmp30_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp31_;
	GtkEventBox* _tmp32_;
	GtkOverlay* _tmp33_;
	GtkEventBox* _tmp34_;
	const gchar* _tmp35_;
	GtkEventBox* _tmp45_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (wallpaper_container_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WALLPAPER_CONTAINER, WallpaperContainer);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	_tmp2_ = style_context;
	gtk_style_context_add_class (_tmp2_, "wallpaper-container");
	_tmp3_ = style_context;
	self->priv->scale = gtk_style_context_get_scale (_tmp3_);
	g_object_set ((GtkWidget*) self, "height-request", WALLPAPER_CONTAINER_THUMB_HEIGHT + 18, NULL);
	g_object_set ((GtkWidget*) self, "width-request", WALLPAPER_CONTAINER_THUMB_WIDTH + 18, NULL);
	_tmp4_ = gtk_css_provider_new ();
	provider = _tmp4_;
	_tmp5_ = provider;
	gtk_css_provider_load_from_resource (_tmp5_, "/io/elementary/switchboard/plug/pantheon-shell/plug.css");
	_tmp6_ = gdk_screen_get_default ();
	_tmp7_ = provider;
	gtk_style_context_add_provider_for_screen (_tmp6_, (GtkStyleProvider*) _tmp7_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp8_ = granite_async_image_new (TRUE, TRUE);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->image);
	self->priv->image = _tmp8_;
	_tmp9_ = self->priv->image;
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
	_tmp10_ = self->priv->image;
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
	_tmp11_ = self->priv->image;
	_tmp12_ = gtk_widget_get_style_context ((GtkWidget*) _tmp11_);
	gtk_style_context_set_scale (_tmp12_, 1);
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->card_box);
	self->priv->card_box = _tmp13_;
	_tmp14_ = self->priv->card_box;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
	gtk_style_context_add_class (_tmp15_, "card");
	_tmp16_ = self->priv->card_box;
	_tmp17_ = self->priv->image;
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = self->priv->card_box;
	g_object_set ((GtkWidget*) _tmp18_, "margin", 9, NULL);
	_tmp19_ = (GtkImage*) gtk_image_new_from_icon_name ("selection-checked", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp19_);
	check = _tmp19_;
	_tmp20_ = check;
	gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_START);
	_tmp21_ = check;
	gtk_widget_set_valign ((GtkWidget*) _tmp21_, GTK_ALIGN_START);
	_tmp22_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (self->priv->check_revealer);
	self->priv->check_revealer = _tmp22_;
	_tmp23_ = self->priv->check_revealer;
	gtk_revealer_set_transition_type (_tmp23_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	_tmp24_ = self->priv->check_revealer;
	_tmp25_ = check;
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp26_);
	overlay = _tmp26_;
	_tmp27_ = overlay;
	_tmp28_ = self->priv->card_box;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = overlay;
	_tmp30_ = self->priv->check_revealer;
	gtk_overlay_add_overlay (_tmp29_, (GtkWidget*) _tmp30_);
	_tmp31_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp31_);
	event_box = _tmp31_;
	_tmp32_ = event_box;
	_tmp33_ = overlay;
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	g_object_set ((GtkWidget*) self, "margin", 6, NULL);
	_tmp34_ = event_box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp34_);
	_tmp35_ = self->priv->_uri;
	if (_tmp35_ != NULL) {
		Block1Data* _data1_;
		GtkMenuItem* _tmp36_;
		GtkMenuItem* _tmp37_;
		const gchar* _tmp38_;
		GFile* _tmp39_;
		GFile* _tmp40_;
		GtkMenu* _tmp41_;
		GtkMenu* _tmp42_;
		GtkMenuItem* _tmp43_;
		GtkMenu* _tmp44_;
		_data1_ = g_slice_new0 (Block1Data);
		_data1_->_ref_count_ = 1;
		_data1_->self = g_object_ref (self);
		_tmp36_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove"));
		g_object_ref_sink (_tmp36_);
		_data1_->move_to_trash = _tmp36_;
		_tmp37_ = _data1_->move_to_trash;
		g_signal_connect_object (_tmp37_, "activate", (GCallback) __wallpaper_container____lambda7__gtk_menu_item_activate, self, 0);
		_tmp38_ = self->priv->_uri;
		_tmp39_ = g_file_new_for_uri (_tmp38_);
		_data1_->file = _tmp39_;
		_tmp40_ = _data1_->file;
		g_file_query_info_async (_tmp40_, G_FILE_ATTRIBUTE_ACCESS_CAN_DELETE, 0, G_PRIORITY_DEFAULT, NULL, __wallpaper_container____lambda8__gasync_ready_callback, block1_data_ref (_data1_));
		_tmp41_ = (GtkMenu*) gtk_menu_new ();
		g_object_ref_sink (_tmp41_);
		_g_object_unref0 (self->priv->context_menu);
		self->priv->context_menu = _tmp41_;
		_tmp42_ = self->priv->context_menu;
		_tmp43_ = _data1_->move_to_trash;
		gtk_menu_shell_append ((GtkMenuShell*) _tmp42_, _tmp43_);
		_tmp44_ = self->priv->context_menu;
		gtk_widget_show_all ((GtkWidget*) _tmp44_);
		block1_data_unref (_data1_);
		_data1_ = NULL;
	}
	g_signal_connect_object ((GtkFlowBoxChild*) self, "activate", (GCallback) __wallpaper_container___lambda9__gtk_flow_box_child_activate, self, 0);
	_tmp45_ = event_box;
	g_signal_connect_object ((GtkWidget*) _tmp45_, "button-press-event", (GCallback) _wallpaper_container_show_context_menu_gtk_widget_button_press_event, self, 0);
	{
		const gchar* _tmp46_;
		_tmp46_ = self->priv->_uri;
		if (_tmp46_ != NULL) {
			gboolean _tmp47_ = FALSE;
			const gchar* _tmp48_;
			_tmp48_ = self->priv->_thumb_path;
			if (_tmp48_ != NULL) {
				gboolean _tmp49_;
				_tmp49_ = self->priv->_thumb_valid;
				_tmp47_ = _tmp49_;
			} else {
				_tmp47_ = FALSE;
			}
			if (_tmp47_) {
				wallpaper_container_update_thumb (self, NULL, NULL);
			} else {
				wallpaper_container_generate_and_load_thumb (self);
			}
		} else {
			GdkPixbuf* _tmp50_;
			GdkPixbuf* _tmp51_;
			GraniteAsyncImage* _tmp52_;
			GdkPixbuf* _tmp53_;
			_tmp50_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, WALLPAPER_CONTAINER_THUMB_WIDTH * self->priv->scale, WALLPAPER_CONTAINER_THUMB_HEIGHT * self->priv->scale);
			_tmp51_ = _tmp50_;
			wallpaper_container_set_thumb (self, _tmp51_);
			_g_object_unref0 (_tmp51_);
			_tmp52_ = self->priv->image;
			_tmp53_ = self->priv->_thumb;
			g_object_set ((GtkImage*) _tmp52_, "gicon", (GIcon*) _tmp53_, NULL);
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp54_;
		const gchar* _tmp55_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp54_ = e;
		_tmp55_ = _tmp54_->message;
		g_critical ("WallpaperContainer.vala:154: Failed to load wallpaper thumbnail: %s", _tmp55_);
		_g_error_free0 (e);
		_g_object_unref0 (event_box);
		_g_object_unref0 (overlay);
		_g_object_unref0 (check);
		_g_object_unref0 (provider);
		_g_object_unref0 (style_context);
		return obj;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (event_box);
		_g_object_unref0 (overlay);
		_g_object_unref0 (check);
		_g_object_unref0 (provider);
		_g_object_unref0 (style_context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_g_object_unref0 (event_box);
	_g_object_unref0 (overlay);
	_g_object_unref0 (check);
	_g_object_unref0 (provider);
	_g_object_unref0 (style_context);
	return obj;
}

static void
wallpaper_container_class_init (WallpaperContainerClass * klass,
                                gpointer klass_data)
{
	wallpaper_container_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WallpaperContainer_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_wallpaper_container_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_wallpaper_container_set_property;
	G_OBJECT_CLASS (klass)->constructor = wallpaper_container_constructor;
	G_OBJECT_CLASS (klass)->finalize = wallpaper_container_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY] = g_param_spec_string ("thumb-path", "thumb-path", "thumb-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY] = g_param_spec_boolean ("thumb-valid", "thumb-valid", "thumb-valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_URI_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_THUMB_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_THUMB_PROPERTY] = g_param_spec_object ("thumb", "thumb", "thumb", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_CHECKED_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_CHECKED_PROPERTY] = g_param_spec_boolean ("checked", "checked", "checked", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLPAPER_CONTAINER_SELECTED_PROPERTY, wallpaper_container_properties[WALLPAPER_CONTAINER_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	wallpaper_container_signals[WALLPAPER_CONTAINER_TRASH_SIGNAL] = g_signal_new ("trash", TYPE_WALLPAPER_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
wallpaper_container_instance_init (WallpaperContainer * self,
                                   gpointer klass)
{
	self->priv = wallpaper_container_get_instance_private (self);
}

static void
wallpaper_container_finalize (GObject * obj)
{
	WallpaperContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WALLPAPER_CONTAINER, WallpaperContainer);
	_g_object_unref0 (self->priv->card_box);
	_g_object_unref0 (self->priv->context_menu);
	_g_object_unref0 (self->priv->check_revealer);
	_g_object_unref0 (self->priv->image);
	_g_free0 (self->priv->_thumb_path);
	_g_free0 (self->priv->_uri);
	_g_object_unref0 (self->priv->_thumb);
	G_OBJECT_CLASS (wallpaper_container_parent_class)->finalize (obj);
}

static GType
wallpaper_container_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WallpaperContainerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallpaper_container_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WallpaperContainer), 0, (GInstanceInitFunc) wallpaper_container_instance_init, NULL };
	GType wallpaper_container_type_id;
	wallpaper_container_type_id = g_type_register_static (gtk_flow_box_child_get_type (), "WallpaperContainer", &g_define_type_info, 0);
	WallpaperContainer_private_offset = g_type_add_instance_private (wallpaper_container_type_id, sizeof (WallpaperContainerPrivate));
	return wallpaper_container_type_id;
}

GType
wallpaper_container_get_type (void)
{
	static volatile gsize wallpaper_container_type_id__volatile = 0;
	if (g_once_init_enter (&wallpaper_container_type_id__volatile)) {
		GType wallpaper_container_type_id;
		wallpaper_container_type_id = wallpaper_container_get_type_once ();
		g_once_init_leave (&wallpaper_container_type_id__volatile, wallpaper_container_type_id);
	}
	return wallpaper_container_type_id__volatile;
}

static void
_vala_wallpaper_container_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	WallpaperContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WALLPAPER_CONTAINER, WallpaperContainer);
	switch (property_id) {
		case WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY:
		g_value_set_string (value, wallpaper_container_get_thumb_path (self));
		break;
		case WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY:
		g_value_set_boolean (value, wallpaper_container_get_thumb_valid (self));
		break;
		case WALLPAPER_CONTAINER_URI_PROPERTY:
		g_value_set_string (value, wallpaper_container_get_uri (self));
		break;
		case WALLPAPER_CONTAINER_THUMB_PROPERTY:
		g_value_set_object (value, wallpaper_container_get_thumb (self));
		break;
		case WALLPAPER_CONTAINER_CHECKED_PROPERTY:
		g_value_set_boolean (value, wallpaper_container_get_checked (self));
		break;
		case WALLPAPER_CONTAINER_SELECTED_PROPERTY:
		g_value_set_boolean (value, wallpaper_container_get_selected (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_wallpaper_container_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	WallpaperContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WALLPAPER_CONTAINER, WallpaperContainer);
	switch (property_id) {
		case WALLPAPER_CONTAINER_THUMB_PATH_PROPERTY:
		wallpaper_container_set_thumb_path (self, g_value_get_string (value));
		break;
		case WALLPAPER_CONTAINER_THUMB_VALID_PROPERTY:
		wallpaper_container_set_thumb_valid (self, g_value_get_boolean (value));
		break;
		case WALLPAPER_CONTAINER_URI_PROPERTY:
		wallpaper_container_set_uri (self, g_value_get_string (value));
		break;
		case WALLPAPER_CONTAINER_THUMB_PROPERTY:
		wallpaper_container_set_thumb (self, g_value_get_object (value));
		break;
		case WALLPAPER_CONTAINER_CHECKED_PROPERTY:
		wallpaper_container_set_checked (self, g_value_get_boolean (value));
		break;
		case WALLPAPER_CONTAINER_SELECTED_PROPERTY:
		wallpaper_container_set_selected (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

